## vorbisenc

vorbisenc

## Properties

gint | bitrate | Read / Write
gchar * | last-message | Read
gboolean | managed | Read / Write
gint | max-bitrate | Read / Write
gint | min-bitrate | Read / Write
gfloat | quality | Read / Write

## Types and Values

struct | GstVorbisEnc

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstAudioEncoder
                        ╰── GstVorbisEnc

## Implemented Interfaces

GstVorbisEnc implements GstPreset and GstTagSetter.

## Description

This element encodes raw float audio into a Vorbis stream.

Vorbis is a royalty-free

audio codec maintained by the Xiph.org Foundation.

#### Example pipelines

    1

    gst-launch-1.0 -v audiotestsrc wave=sine num-buffers=100 ! audioconvert ! vorbisenc ! oggmux ! filesink location=sine.ogg

Encode a test sine signal to Ogg/Vorbis. Note that the resulting file will be really small because a sine signal compresses very well.

    1

    gst-launch-1.0 -v autoaudiosrc ! audioconvert ! vorbisenc ! oggmux ! filesink location=alsasrc.ogg

Record from a sound card and encode to Ogg/Vorbis.

## Synopsis

### Element Information

plugin | vorbis
author | Monty <monty@xiph.org>, Wim Taymans <wim@fluendo.com>
class | Codec/Encoder/Audio

### Element Pads

name | sink
direction | sink
presence | always
details | audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)1
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)2, channel-mask=(bitmask)0x0000000000000003
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)3, channel-mask=(bitmask)0x0000000000000007
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)4, channel-mask=(bitmask)0x0000000000000033
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)5, channel-mask=(bitmask)0x0000000000000037
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)6, channel-mask=(bitmask)0x000000000000003f
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)7, channel-mask=(bitmask)0x0000000000000d0f
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)8, channel-mask=(bitmask)0x0000000000000c3f
| audio/x-raw, format=(string)F32LE, layout=(string)interleaved, rate=(int)[ 1, 200000 ], channels=(int)[ 9, 255 ], channel-mask=(bitmask)0x0000000000000000

name | src
direction | source
presence | always
details | audio/x-vorbis, rate=(int)[ 1, 200000 ], channels=(int)[ 1, 255 ]

## Functions

## Types and Values

### struct GstVorbisEnc

    struct GstVorbisEnc;

Opaque data structure.

## Property Details

### The `“bitrate”` property

      “bitrate”                  gint

Attempt to encode at a bitrate averaging this (in bps). This uses the bitrate management engine, and is not recommended for most users. Quality is a better alternative. (-1 == disabled).

Flags: Read / Write

Allowed values: [G_MAXULONG,250001]

Default value: -1

### The `“last-message”` property

      “last-message”             gchar *

The last status message.

Flags: Read

Default value: NULL

### The `“managed”` property

      “managed”                  gboolean

Enable bitrate management engine.

Flags: Read / Write

Default value: FALSE

### The `“max-bitrate”` property

      “max-bitrate”              gint

Specify a maximum bitrate (in bps). Useful for streaming applications. (-1 == disabled).

Flags: Read / Write

Allowed values: [G_MAXULONG,250001]

Default value: -1

### The `“min-bitrate”` property

      “min-bitrate”              gint

Specify a minimum bitrate (in bps). Useful for encoding for a fixed-size channel. (-1 == disabled).

Flags: Read / Write

Allowed values: [G_MAXULONG,250001]

Default value: -1

### The `“quality”` property

      “quality”                  gfloat

Specify quality instead of specifying a particular bitrate.

Flags: Read / Write

Allowed values: [-0.1,1]

Default value: 0.3

## See Also

vorbisdec, oggmux